import { AbstractModel } from "../model/AbstractModel";
import { DtoFieldMetadata } from "./DtoFieldMetadata";
import { Constructor } from "../common/types";
export declare type OmitProps = "name" | "dataType";
declare type FieldProps = Omit<DtoFieldMetadata, OmitProps>;
/**
 * A simple data transfer object.
 */
export declare const Data: (config?: {
    /**
     * Strict:
     * - only fields in metadata are accepted
     * - strict type checking
     */
    strict?: boolean | undefined;
    /**
     * Make all fields of metadata isRequired = false
     */
    partial?: boolean | undefined;
} | undefined) => (constructor: Constructor<any>) => Constructor<any>;
export declare const Field: (config: FieldProps) => (prototype: any, propertyKey: string) => void;
export declare const Relation: (model: Constructor<AbstractModel>) => Partial<FieldProps>;
export {};
